import{S as Ls,i as Hs,s as Fs,e as l,k as i,w as g,t as m,M as Os,c as r,d as a,m as p,a as o,x as b,h as _,b as c,G as t,g as n,y as x,L as Us,q as j,o as $,B as q,v as Rs}from"../chunks/vendor-hf-doc-builder.js";import{I as js}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as B}from"../chunks/CodeBlock-hf-doc-builder.js";function Bs($s){let h,G,u,y,K,E,ms,L,_s,J,D,hs,Q,C,V,d,v,H,M,us,F,ds,X,N,fs,Y,A,ys,Z,S,ss,w,vs,O,ws,ks,as,P,es,f,k,U,W,gs,R,bs,ts,I,xs,ns,z,ls,T,rs;return E=new js({}),C=new B({props:{code:`import numpy as np
from tensorflow import keras
from tensorflow.keras import layers
import evaluate

# We pull example code from Keras.io's guide on classifying with MNIST
# Located here: https://keras.io/examples/vision/mnist_convnet/

# Model / data parameters
input_shape = (28, 28, 1)

# Load the data and split it between train and test sets
(x_train, y_train), (x_test, y_test) = keras.datasets.fashion_mnist.load_data()


# Only select tshirts/tops and trousers, classes 0 and 1
def get_tshirts_tops_and_trouser(x_vals, y_vals):
    mask = np.where((y_vals == 0) | (y_vals == 1))
    return x_vals[mask], y_vals[mask]

x_train, y_train = get_tshirts_tops_and_trouser(x_train, y_train)
x_test, y_test = get_tshirts_tops_and_trouser(x_test, y_test)


# Scale images to the [0, 1] range
x_train = x_train.astype("float32") / 255
x_test = x_test.astype("float32") / 255

x_train = np.expand_dims(x_train, -1)
x_test = np.expand_dims(x_test, -1)


model = keras.Sequential(
    [
        keras.Input(shape=input_shape),
        layers.Conv2D(32, kernel_size=(3, 3), activation="relu"),
        layers.MaxPooling2D(pool_size=(2, 2)),
        layers.Conv2D(64, kernel_size=(3, 3), activation="relu"),
        layers.MaxPooling2D(pool_size=(2, 2)),
        layers.Flatten(),
        layers.Dropout(0.5),
        layers.Dense(1, activation="sigmoid"),
    ]
)`,highlighted:`<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> tensorflow <span class="hljs-keyword">import</span> keras
<span class="hljs-keyword">from</span> tensorflow.keras <span class="hljs-keyword">import</span> layers
<span class="hljs-keyword">import</span> evaluate

<span class="hljs-comment"># We pull example code from Keras.io&#x27;s guide on classifying with MNIST</span>
<span class="hljs-comment"># Located here: https://keras.io/examples/vision/mnist_convnet/</span>

<span class="hljs-comment"># Model / data parameters</span>
input_shape = (<span class="hljs-number">28</span>, <span class="hljs-number">28</span>, <span class="hljs-number">1</span>)

<span class="hljs-comment"># Load the data and split it between train and test sets</span>
(x_train, y_train), (x_test, y_test) = keras.datasets.fashion_mnist.load_data()


<span class="hljs-comment"># Only select tshirts/tops and trousers, classes 0 and 1</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">get_tshirts_tops_and_trouser</span>(<span class="hljs-params">x_vals, y_vals</span>):
    mask = np.where((y_vals == <span class="hljs-number">0</span>) | (y_vals == <span class="hljs-number">1</span>))
    <span class="hljs-keyword">return</span> x_vals[mask], y_vals[mask]

x_train, y_train = get_tshirts_tops_and_trouser(x_train, y_train)
x_test, y_test = get_tshirts_tops_and_trouser(x_test, y_test)


<span class="hljs-comment"># Scale images to the [0, 1] range</span>
x_train = x_train.astype(<span class="hljs-string">&quot;float32&quot;</span>) / <span class="hljs-number">255</span>
x_test = x_test.astype(<span class="hljs-string">&quot;float32&quot;</span>) / <span class="hljs-number">255</span>

x_train = np.expand_dims(x_train, -<span class="hljs-number">1</span>)
x_test = np.expand_dims(x_test, -<span class="hljs-number">1</span>)


model = keras.Sequential(
    [
        keras.Input(shape=input_shape),
        layers.Conv2D(<span class="hljs-number">32</span>, kernel_size=(<span class="hljs-number">3</span>, <span class="hljs-number">3</span>), activation=<span class="hljs-string">&quot;relu&quot;</span>),
        layers.MaxPooling2D(pool_size=(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)),
        layers.Conv2D(<span class="hljs-number">64</span>, kernel_size=(<span class="hljs-number">3</span>, <span class="hljs-number">3</span>), activation=<span class="hljs-string">&quot;relu&quot;</span>),
        layers.MaxPooling2D(pool_size=(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)),
        layers.Flatten(),
        layers.Dropout(<span class="hljs-number">0.5</span>),
        layers.Dense(<span class="hljs-number">1</span>, activation=<span class="hljs-string">&quot;sigmoid&quot;</span>),
    ]
)`}}),M=new js({}),S=new B({props:{code:`class MetricsCallback(keras.callbacks.Callback):

    def __init__(self, metric_name, x_data, y_data) -> None:
        super(MetricsCallback, self).__init__()

        self.x_data = x_data
        self.y_data = y_data
        self.metric_name = metric_name
        self.metric = evaluate.load(metric_name)

    def on_epoch_end(self, epoch, logs=dict()):
        m = self.model 
        # Ensure we get labels of "1" or "0"
        training_preds = np.round(m.predict(self.x_data))
        training_labels = self.y_data

        # Compute score and save
        score = self.metric.compute(predictions = training_preds, references = training_labels)
        
        logs.update(score)`,highlighted:`<span class="hljs-keyword">class</span> <span class="hljs-title class_">MetricsCallback</span>(keras.callbacks.Callback):

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self, metric_name, x_data, y_data</span>) -&gt; <span class="hljs-literal">None</span>:
        <span class="hljs-built_in">super</span>(MetricsCallback, self).__init__()

        self.x_data = x_data
        self.y_data = y_data
        self.metric_name = metric_name
        self.metric = evaluate.load(metric_name)

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">on_epoch_end</span>(<span class="hljs-params">self, epoch, logs=<span class="hljs-built_in">dict</span>(<span class="hljs-params"></span>)</span>):
        m = self.model 
        <span class="hljs-comment"># Ensure we get labels of &quot;1&quot; or &quot;0&quot;</span>
        training_preds = np.<span class="hljs-built_in">round</span>(m.predict(self.x_data))
        training_labels = self.y_data

        <span class="hljs-comment"># Compute score and save</span>
        score = self.metric.compute(predictions = training_preds, references = training_labels)
        
        logs.update(score)`}}),P=new B({props:{code:`batch_size = 128
epochs = 2

model.compile(loss="binary_crossentropy", optimizer="adam")

model_history = model.fit(x_train, y_train, batch_size=batch_size, epochs=epochs, validation_split=0.1, 
callbacks = [MetricsCallback(x_data = x_train, y_data = y_train, metric_name = "accuracy")])`,highlighted:`batch_size = <span class="hljs-number">128</span>
epochs = <span class="hljs-number">2</span>

model.<span class="hljs-built_in">compile</span>(loss=<span class="hljs-string">&quot;binary_crossentropy&quot;</span>, optimizer=<span class="hljs-string">&quot;adam&quot;</span>)

model_history = model.fit(x_train, y_train, batch_size=batch_size, epochs=epochs, validation_split=<span class="hljs-number">0.1</span>, 
callbacks = [MetricsCallback(x_data = x_train, y_data = y_train, metric_name = <span class="hljs-string">&quot;accuracy&quot;</span>)])`}}),W=new js({}),z=new B({props:{code:`acc = evaluate.load("accuracy")
# Round the predictions to turn them into "0" or "1" labels
test_preds = np.round(model.predict(x_test))
test_labels = y_test`,highlighted:`acc = evaluate.load(<span class="hljs-string">&quot;accuracy&quot;</span>)
<span class="hljs-comment"># Round the predictions to turn them into &quot;0&quot; or &quot;1&quot; labels</span>
test_preds = np.<span class="hljs-built_in">round</span>(model.predict(x_test))
test_labels = y_test`}}),T=new B({props:{code:`print("Test accuracy is : ", acc.compute(predictions = test_preds, references = test_labels))
# Test accuracy is : 0.9855`,highlighted:`<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Test accuracy is : &quot;</span>, acc.compute(predictions = test_preds, references = test_labels))
<span class="hljs-comment"># Test accuracy is : 0.9855</span>`}}),{c(){h=l("meta"),G=i(),u=l("h1"),y=l("a"),K=l("span"),g(E.$$.fragment),ms=i(),L=l("span"),_s=m("Working with Keras and Tensorflow"),J=i(),D=l("p"),hs=m("Evaluate can be easily intergrated into your Keras and Tensorflow workflow. We\u2019ll demonstrate two ways of incorporating Evaluate into model training, using the Fashion MNIST example dataset. We\u2019ll train a standard classifier to predict two classes from this dataset, and show how to use a metric as a callback during training or afterwards for evaluation."),Q=i(),g(C.$$.fragment),V=i(),d=l("h2"),v=l("a"),H=l("span"),g(M.$$.fragment),us=i(),F=l("span"),ds=m("Callbacks"),X=i(),N=l("p"),fs=m("Suppose we want to keep track of model metrics while a model is training. We can use a Callback in order to calculate this metric during training, after an epoch ends."),Y=i(),A=l("p"),ys=m("We\u2019ll define a callback here that will take a metric name and our training data, and have it calculate a metric after the epoch ends."),Z=i(),g(S.$$.fragment),ss=i(),w=l("p"),vs=m("We can pass this class to the "),O=l("code"),ws=m("callbacks"),ks=m(" keyword-argument to use it during training:"),as=i(),g(P.$$.fragment),es=i(),f=l("h2"),k=l("a"),U=l("span"),g(W.$$.fragment),gs=i(),R=l("span"),bs=m("Using an Evaluate Metric for... Evaluation!"),ts=i(),I=l("p"),xs=m("We can also use the same metric after model training! Here, we show how to check accuracy of the model after training on the test set:"),ns=i(),g(z.$$.fragment),ls=i(),g(T.$$.fragment),this.h()},l(s){const e=Os('[data-svelte="svelte-1phssyn"]',document.head);h=r(e,"META",{name:!0,content:!0}),e.forEach(a),G=p(s),u=r(s,"H1",{class:!0});var os=o(u);y=r(os,"A",{id:!0,class:!0,href:!0});var qs=o(y);K=r(qs,"SPAN",{});var Es=o(K);b(E.$$.fragment,Es),Es.forEach(a),qs.forEach(a),ms=p(os),L=r(os,"SPAN",{});var Cs=o(L);_s=_(Cs,"Working with Keras and Tensorflow"),Cs.forEach(a),os.forEach(a),J=p(s),D=r(s,"P",{});var Ms=o(D);hs=_(Ms,"Evaluate can be easily intergrated into your Keras and Tensorflow workflow. We\u2019ll demonstrate two ways of incorporating Evaluate into model training, using the Fashion MNIST example dataset. We\u2019ll train a standard classifier to predict two classes from this dataset, and show how to use a metric as a callback during training or afterwards for evaluation."),Ms.forEach(a),Q=p(s),b(C.$$.fragment,s),V=p(s),d=r(s,"H2",{class:!0});var is=o(d);v=r(is,"A",{id:!0,class:!0,href:!0});var Ss=o(v);H=r(Ss,"SPAN",{});var Ps=o(H);b(M.$$.fragment,Ps),Ps.forEach(a),Ss.forEach(a),us=p(is),F=r(is,"SPAN",{});var Ws=o(F);ds=_(Ws,"Callbacks"),Ws.forEach(a),is.forEach(a),X=p(s),N=r(s,"P",{});var zs=o(N);fs=_(zs,"Suppose we want to keep track of model metrics while a model is training. We can use a Callback in order to calculate this metric during training, after an epoch ends."),zs.forEach(a),Y=p(s),A=r(s,"P",{});var Ts=o(A);ys=_(Ts,"We\u2019ll define a callback here that will take a metric name and our training data, and have it calculate a metric after the epoch ends."),Ts.forEach(a),Z=p(s),b(S.$$.fragment,s),ss=p(s),w=r(s,"P",{});var ps=o(w);vs=_(ps,"We can pass this class to the "),O=r(ps,"CODE",{});var Ds=o(O);ws=_(Ds,"callbacks"),Ds.forEach(a),ks=_(ps," keyword-argument to use it during training:"),ps.forEach(a),as=p(s),b(P.$$.fragment,s),es=p(s),f=r(s,"H2",{class:!0});var cs=o(f);k=r(cs,"A",{id:!0,class:!0,href:!0});var Ns=o(k);U=r(Ns,"SPAN",{});var As=o(U);b(W.$$.fragment,As),As.forEach(a),Ns.forEach(a),gs=p(cs),R=r(cs,"SPAN",{});var Is=o(R);bs=_(Is,"Using an Evaluate Metric for... Evaluation!"),Is.forEach(a),cs.forEach(a),ts=p(s),I=r(s,"P",{});var Ks=o(I);xs=_(Ks,"We can also use the same metric after model training! Here, we show how to check accuracy of the model after training on the test set:"),Ks.forEach(a),ns=p(s),b(z.$$.fragment,s),ls=p(s),b(T.$$.fragment,s),this.h()},h(){c(h,"name","hf:doc:metadata"),c(h,"content",JSON.stringify(Gs)),c(y,"id","working-with-keras-and-tensorflow"),c(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(y,"href","#working-with-keras-and-tensorflow"),c(u,"class","relative group"),c(v,"id","callbacks"),c(v,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(v,"href","#callbacks"),c(d,"class","relative group"),c(k,"id","using-an-evaluate-metric-for-evaluation"),c(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(k,"href","#using-an-evaluate-metric-for-evaluation"),c(f,"class","relative group")},m(s,e){t(document.head,h),n(s,G,e),n(s,u,e),t(u,y),t(y,K),x(E,K,null),t(u,ms),t(u,L),t(L,_s),n(s,J,e),n(s,D,e),t(D,hs),n(s,Q,e),x(C,s,e),n(s,V,e),n(s,d,e),t(d,v),t(v,H),x(M,H,null),t(d,us),t(d,F),t(F,ds),n(s,X,e),n(s,N,e),t(N,fs),n(s,Y,e),n(s,A,e),t(A,ys),n(s,Z,e),x(S,s,e),n(s,ss,e),n(s,w,e),t(w,vs),t(w,O),t(O,ws),t(w,ks),n(s,as,e),x(P,s,e),n(s,es,e),n(s,f,e),t(f,k),t(k,U),x(W,U,null),t(f,gs),t(f,R),t(R,bs),n(s,ts,e),n(s,I,e),t(I,xs),n(s,ns,e),x(z,s,e),n(s,ls,e),x(T,s,e),rs=!0},p:Us,i(s){rs||(j(E.$$.fragment,s),j(C.$$.fragment,s),j(M.$$.fragment,s),j(S.$$.fragment,s),j(P.$$.fragment,s),j(W.$$.fragment,s),j(z.$$.fragment,s),j(T.$$.fragment,s),rs=!0)},o(s){$(E.$$.fragment,s),$(C.$$.fragment,s),$(M.$$.fragment,s),$(S.$$.fragment,s),$(P.$$.fragment,s),$(W.$$.fragment,s),$(z.$$.fragment,s),$(T.$$.fragment,s),rs=!1},d(s){a(h),s&&a(G),s&&a(u),q(E),s&&a(J),s&&a(D),s&&a(Q),q(C,s),s&&a(V),s&&a(d),q(M),s&&a(X),s&&a(N),s&&a(Y),s&&a(A),s&&a(Z),q(S,s),s&&a(ss),s&&a(w),s&&a(as),q(P,s),s&&a(es),s&&a(f),q(W),s&&a(ts),s&&a(I),s&&a(ns),q(z,s),s&&a(ls),q(T,s)}}}const Gs={local:"working-with-keras-and-tensorflow",sections:[{local:"callbacks",title:"Callbacks"},{local:"using-an-evaluate-metric-for-evaluation",title:"Using an Evaluate Metric for... Evaluation!"}],title:"Working with Keras and Tensorflow"};function Js($s){return Rs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ys extends Ls{constructor(h){super();Hs(this,h,Js,Bs,Fs,{})}}export{Ys as default,Gs as metadata};
