import{S as se,i as ce,s as de,e as o,k as x,w as U,t as E,M as pe,c as i,d as t,m as b,a as n,x as W,h as D,b as r,G as a,g as f,y as j,L as ue,q as K,o as Q,B as X,v as he}from"../../chunks/vendor-hf-doc-builder.js";import{D as fe}from"../../chunks/Docstring-hf-doc-builder.js";import{I as le}from"../../chunks/IconCopyLink-hf-doc-builder.js";function me(Y){let s,P,c,u,$,m,V,y,I,T,w,R,C,d,h,k,v,F,q,H,S,p,_,B,z,G,g,J,A;return m=new le({}),v=new le({}),_=new fe({props:{name:"evaluate.visualization.radar_plot",anchor:"evaluate.visualization.radar_plot",parameters:[{name:"data",val:""},{name:"model_names",val:""},{name:"invert_range",val:" = []"},{name:"config",val:" = None"},{name:"fig",val:" = None"}],parametersDescription:[{anchor:"evaluate.visualization.radar_plot.data",description:`<strong>data</strong> (<code>List[dict]</code>) &#x2014; the results (list of metric + value pairs).
E.g. data = [{&#x201C;accuracy&#x201D;: 0.9, &#x201C;precision&#x201D;:0.8},{&#x201C;accuracy&#x201D;: 0.7, &#x201C;precision&#x201D;:0.6}]`,name:"data"},{anchor:"evaluate.visualization.radar_plot.names",description:`<strong>names</strong> (<code>List[dict]</code>) &#x2014; model names.
E.g. names = [&#x201C;model1&#x201D;, &#x201C;model 2&#x201D;, &#x2026;]`,name:"names"},{anchor:"evaluate.visualization.radar_plot.invert_range",description:`<strong>invert_range</strong> (<code>List[dict]</code>, optional) &#x2014; the metrics to invert (in cases when smaller is better, e.g. speed)
E.g. invert_range=[&#x201C;latency_in_seconds&#x201D;]`,name:"invert_range"},{anchor:"evaluate.visualization.radar_plot.config",description:`<strong>config</strong> (<code>dict</code>, optional)  &#x2014; a specification of the formatting configurations, namely:</p>
<ul>
<li>
<p>rad_ln_args (<code>dict</code>, default <code>{&quot;visible&quot;: True}</code>): The visibility of the radial (circle) lines.</p>
</li>
<li>
<p>outer_ring (<code>dict</code>, default <code>{&quot;visible&quot;: True}</code>): The visibility of the outer ring.</p>
</li>
<li>
<p>angle_ln_args (<code>dict</code>, default <code>{&quot;visible&quot;: True}</code>): The visibility of the angle lines.</p>
</li>
<li>
<p>rgrid_tick_lbls_args (<code>dict</code>, default <code>{&quot;fontsize&quot;: 12}</code>): The font size of the tick labels on the scales.</p>
</li>
<li>
<p>theta_tick_lbls (<code>dict</code>, default <code>{&quot;fontsize&quot;: 12}</code>): The font size of the variable labels on the plot.</p>
</li>
<li>
<p>theta_tick_lbls_pad (<code>int</code>, default <code>3</code>): The padding of the variable labels on the plot.</p>
</li>
<li>
<p>theta_tick_lbls_brk_lng_wrds (<code>bool</code>, default <code>True</code> ): Whether long words in the label are broken up or not.</p>
</li>
<li>
<p>theta_tick_lbls_txt_wrap (<code>int</code>, default <code>15</code>): Text wrap for tick labels</p>
</li>
<li>
<p>incl_endpoint (<code>bool</code>, default <code>False</code>): Include value endpoints on calse</p>
</li>
<li>
<p>marker (<code>str</code>, default <code>&quot;o&quot;</code>): the shape of the marker used in the radar plot.</p>
</li>
<li>
<p>markersize (<code>int</code>, default <code>3</code>): the shape of the marker used in the radar plot.</p>
</li>
<li>
<p>legend_loc (<code>str</code>, default <code>&quot;upper right&quot;</code>): the location of the legend in the radar plot. Must be one of: &#x2018;upper left&#x2019;, &#x2018;upper right&#x2019;, &#x2018;lower left&#x2019;, &#x2018;lower right&#x2019;.</p>
</li>
<li>
<p>bbox_to_anchor (<code>tuple</code>, default <code>(2, 1)</code>: anchor for the legend.</p>
</li>
</ul>`,name:"config"},{anchor:"evaluate.visualization.radar_plot.fig",description:"<strong>fig</strong> (<code>matplotlib.figure.Figure</code>, optional) &#x2014; figure used to plot the radar plot.",name:"fig"}],source:"https://github.com/huggingface/evaluate/blob/v0.4.0/src/evaluate/visualization.py#L138",returnDescription:`
<p><code>matplotlib.figure.Figure</code></p>
`}}),{c(){s=o("meta"),P=x(),c=o("h1"),u=o("a"),$=o("span"),U(m.$$.fragment),V=x(),y=o("span"),I=E("Visualization methods"),T=x(),w=o("p"),R=E("Methods for visualizing evaluations results:"),C=x(),d=o("h2"),h=o("a"),k=o("span"),U(v.$$.fragment),F=x(),q=o("span"),H=E("Radar Plot"),S=x(),p=o("div"),U(_.$$.fragment),B=x(),z=o("p"),G=E(`Create a complex radar chart with different scales for each variable
Source: `),g=o("a"),J=E("https://towardsdatascience.com/how-to-create-and-visualize-complex-radar-charts-f7764d0f3652"),this.h()},l(e){const l=pe('[data-svelte="svelte-1phssyn"]',document.head);s=i(l,"META",{name:!0,content:!0}),l.forEach(t),P=b(e),c=i(e,"H1",{class:!0});var L=n(c);u=i(L,"A",{id:!0,class:!0,href:!0});var Z=n(u);$=i(Z,"SPAN",{});var ee=n($);W(m.$$.fragment,ee),ee.forEach(t),Z.forEach(t),V=b(L),y=i(L,"SPAN",{});var te=n(y);I=D(te,"Visualization methods"),te.forEach(t),L.forEach(t),T=b(e),w=i(e,"P",{});var ae=n(w);R=D(ae,"Methods for visualizing evaluations results:"),ae.forEach(t),C=b(e),d=i(e,"H2",{class:!0});var N=n(d);h=i(N,"A",{id:!0,class:!0,href:!0});var oe=n(h);k=i(oe,"SPAN",{});var ie=n(k);W(v.$$.fragment,ie),ie.forEach(t),oe.forEach(t),F=b(N),q=i(N,"SPAN",{});var re=n(q);H=D(re,"Radar Plot"),re.forEach(t),N.forEach(t),S=b(e),p=i(e,"DIV",{class:!0});var M=n(p);W(_.$$.fragment,M),B=b(M),z=i(M,"P",{});var O=n(z);G=D(O,`Create a complex radar chart with different scales for each variable
Source: `),g=i(O,"A",{href:!0,rel:!0});var ne=n(g);J=D(ne,"https://towardsdatascience.com/how-to-create-and-visualize-complex-radar-charts-f7764d0f3652"),ne.forEach(t),O.forEach(t),M.forEach(t),this.h()},h(){r(s,"name","hf:doc:metadata"),r(s,"content",JSON.stringify(ve)),r(u,"id","visualization-methods"),r(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(u,"href","#visualization-methods"),r(c,"class","relative group"),r(h,"id","evaluate.visualization.radar_plot"),r(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(h,"href","#evaluate.visualization.radar_plot"),r(d,"class","relative group"),r(g,"href","https://towardsdatascience.com/how-to-create-and-visualize-complex-radar-charts-f7764d0f3652"),r(g,"rel","nofollow"),r(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,l){a(document.head,s),f(e,P,l),f(e,c,l),a(c,u),a(u,$),j(m,$,null),a(c,V),a(c,y),a(y,I),f(e,T,l),f(e,w,l),a(w,R),f(e,C,l),f(e,d,l),a(d,h),a(h,k),j(v,k,null),a(d,F),a(d,q),a(q,H),f(e,S,l),f(e,p,l),j(_,p,null),a(p,B),a(p,z),a(z,G),a(z,g),a(g,J),A=!0},p:ue,i(e){A||(K(m.$$.fragment,e),K(v.$$.fragment,e),K(_.$$.fragment,e),A=!0)},o(e){Q(m.$$.fragment,e),Q(v.$$.fragment,e),Q(_.$$.fragment,e),A=!1},d(e){t(s),e&&t(P),e&&t(c),X(m),e&&t(T),e&&t(w),e&&t(C),e&&t(d),X(v),e&&t(S),e&&t(p),X(_)}}}const ve={local:"visualization-methods",sections:[{local:"evaluate.visualization.radar_plot",title:"Radar Plot"}],title:"Visualization methods"};function _e(Y){return he(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class we extends se{constructor(s){super();ce(this,s,_e,me,de,{})}}export{we as default,ve as metadata};
